package com.indicee.api.connector;

/**
 * Enum representing mime types
 */
public enum MimeType {
    CAL("text/cal"), 
    CSV("application/csv"), 
    EXCEL("application/vnd.ms-excel"), 
    FORM("application/x-www-form-urlencoded"),
    IMAGE_GIF("image/gif"), 
    IMAGE_JPEG("image/jpeg"), 
    IMAGE_PNG("image/png"), 
    JSON("application/json"),
    TSV("text/tsv"), 
    XML("application/xml");
    
    private final String contentType;

    private MimeType(String contentType) {
        this.contentType = contentType;
    }

    /**
     * Returns the content type String of this MimeType
     */
    public String getContentType() {
        return contentType;
    }
}