package com.indicee.api.connector.exception;

import java.io.Serializable;

/**
 * This exception is thrown by the IndiceeAPIConnector. It gets thrown
 * when there is some sort of connection issue with the Indicee server, or the
 * server returns an error.
 * 
 * @author victork
 * 
 */
public class IndiceeAPIConnectorException extends Exception implements Serializable {

    private static final long serialVersionUID = -1569772755250358646L;
    private String path;

    public IndiceeAPIConnectorException() {
        super();
    }

    public IndiceeAPIConnectorException(String message) {
        super(message);
    }

    public IndiceeAPIConnectorException(String message, String path) {
        super(message);
        this.path = path;
    }
    
    public IndiceeAPIConnectorException(String message, String path, Throwable t) {
        super(message, t);
        this.path = path;
    }

    public IndiceeAPIConnectorException(String message, Throwable t) {
        super(message, t);
    }

    public String getPath() {
        return path;
    }
    
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("PATH: ");
		sb.append(path);
		sb.append("\nMESSAGE: ");
		sb.append(getMessage());
		return sb.toString();
	}
}
