package com.indicee.api.connector.exception;

import java.io.Serializable;

/**
 * This exception gets thrown by calls to IndiceeAPIConnectorFactory
 * @author thaggie
 */
public class IndiceeAPIConnectorFactoryException extends Exception implements Serializable {

	private static final long serialVersionUID = 1L;
	
	public enum Problem {
		NoKey, 
		InvalidKey, 
		ErrorCheckingKey, 
		NotAuthorized,
		ErrorListingTokens 
	}
	
	private final Problem problem;

	public IndiceeAPIConnectorFactoryException(Problem problem) {
		super();
		this.problem = problem;
	}
	
	public IndiceeAPIConnectorFactoryException(Problem problem, Throwable t) {
		super(t);
		this.problem = problem;
	}
	
	public Problem getProblem() {
		return problem;
	}
	
	@Override
	public String toString() {
		return problem.toString();
	}
}
