package com.indicee.api.connector.exception;

import java.io.Serializable;

/**
 * This exception is thrown by the IndiceeAPIConnector. It is thrown
 * when the Indicee server returns an error.
 * 
 * @author victork
 * 
 */
public class IndiceeAPIStatusException extends IndiceeAPIConnectorException implements Serializable {

	private int status;
	private int code;
	
    private static final long serialVersionUID = 7847286323239064156L;

    @SuppressWarnings("unused")
	private IndiceeAPIStatusException() {
        super();
    }

    public IndiceeAPIStatusException(int status, int code, String message, String path) {
        super(message, path);    	
    	this.status = status;
    	this.code = code;
    }
    
	public int getStatus() {
		return status;
	}
	
	public int getCode() {
		return code;
	}
    
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder(super.toString());
		sb.append("\nSTATUS: ");
		sb.append(status);
		sb.append(" CODE: ");
		sb.append(code);
		return sb.toString();
	}
}
