package com.indicee.api.objects;

/**
 * 
 * @author aminy
 *
 */
public abstract class IndiceeQualifiedObject extends IndiceeObject {
	
	private static final long serialVersionUID = -2021476606192604654L;
	private Long id;
	private String qname;
	private String name;
	private Long ownerId;
	
	public Long getId() {
		return id;
	}
	public String getQname() {
		return qname;
	}
	public String getName() {
		return name;
	}
	public Long getOwnerId() {
		return ownerId;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public void setQname(String qname) {
		this.qname = qname;
	}
	public void setName(String name) {
		this.name = name;
	}
	public void setOwnerId(Long ownerId) {
		this.ownerId = ownerId;
	}
	
	public String printQualifiedEntities() {
		return printQualifiedEntities(null,null,null);
	}
	
	public String printQualifiedEntities(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();

		if(id!=null && id!=0) {
			sb.append("<id>").append(id).append("</id>");
		}
		
		if(qname!=null){
			sb.append("<qname>").append(qname).append("</qname>");
		}
		
		if(name!=null){
			sb.append("<name>").append(htmlEncode(name)).append("</name>");
		}
		
		if(ownerId!=null){
			sb.append("<owner_id>").append(ownerId).append("</owner_id>");
		}
		
		return sb.toString();
	}
}
