package com.indicee.api.objects.account;

import java.io.Serializable;

import com.indicee.api.objects.IndiceeObject;

public class Attribute implements Serializable {

    private static final long serialVersionUID = -3985911853731623913L;
    private boolean hierarchy;
    private String name;
    private String value;

    public Attribute() {

    }

    public Attribute(String name, String value, boolean hierarchy) {
        this.value = value;
        this.hierarchy = hierarchy;
        this.name = name;
    }

    public boolean getHierarchy() {
        return hierarchy;
    }

    public String getName() {
        return name;
    }

    public String getValue() {
        return value;
    }

    public void setHierarchy(boolean hierarchy) {
        this.hierarchy = hierarchy;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    public String toString(String newLine, String tab, String indent) {
        return indent + "<account_attribute value=\"" + IndiceeObject.htmlEncode(value) + "\" hierarchical=\"" + hierarchy + "\" name=\"" + name
                + "\" />";
    }
}
