package com.indicee.api.objects.auth;

import com.indicee.api.objects.IndiceeObject;

public class Token extends IndiceeObject {

    private static final long serialVersionUID = 260329345525101703L;
    private String consumerKey;
    private String key;
    private Long ownerID;
    private String secret;

    public String getConsumerKey() {
        return consumerKey;
    }

    public String getKey() {
        return key;
    }

    public Long getOwnerID() {
        return ownerID;
    }

    public String getSecret() {
        return secret;
    }

    public void setConsumerKey(String consumerKey) {
        this.consumerKey = consumerKey;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public void setOwnerID(Long ownerID) {
        this.ownerID = ownerID;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<token>").append(newLine);
        if (consumerKey != null) {
            sb.append(tab).append(indent).append("<consumerKey>").append(consumerKey).append("</consumerKey>").append(
                    newLine);
        }
        if (ownerID != null) {
            sb.append(tab).append(indent).append("<ownerID>").append(ownerID).append("</ownerID>").append(newLine);
        }
        if (key != null) {
            sb.append(tab).append(indent).append("<key>").append(key).append("</key>").append(newLine);
        }
        if (secret != null) {
            sb.append(tab).append(indent).append("<secret>").append(secret).append("</secret>").append(newLine);
        }
        sb.append(indent).append("</token>");
        return sb.toString();
    }

}
