package com.indicee.api.objects.collection;

import java.util.List;

import com.indicee.api.objects.IndiceeQualifiedObject;

public class Collection extends IndiceeQualifiedObject {

	private static final long serialVersionUID = 425695692601512515L;

	private String description;
	private List<String> dataSetQnames;

	private Boolean deleted = Boolean.FALSE;

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List<String> getDataSetQnames() {
		return dataSetQnames;
	}

	public void setDataSetQnames(List<String> dataSetQnames) {
		this.dataSetQnames = dataSetQnames;
	}

	public Boolean getDeleted() {
		return deleted;
	}

	public void setDeleted(Boolean deleted) {
		this.deleted = deleted;
	}
	
	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		sb.append("<collection>");

		sb.append(tab).append(printQualifiedEntities(newLine,tab,indent)).append(newLine);
		
		if(description!=null){
			sb.append("<description>");
			sb.append(htmlEncode(description));
			sb.append("</description>");
		}

		if (dataSetQnames!=null){
			sb.append("<datasets>");
			for(String qname : dataSetQnames){
				sb.append("<dataset>");
				sb.append(qname);
				sb.append("</dataset>");
			}
			sb.append("</datasets>");
		}
		
		sb.append("<deleted>");
		sb.append(deleted);
		sb.append("</deleted>");
		
		
		
		sb.append("</collection>");
		return sb.toString();
	}
}
