package com.indicee.api.objects.contribution;

import java.util.Date;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Contribution extends IndiceeObject {

    private static final long serialVersionUID = -2290287468866213313L;
    private long id;
    private String name;
    private String datasetQName;
    private long ownerID;
    private long size;
    private Status status;
    private String uniqueName;
    private int rowsRead;
    private int rowsProcessed;
    private Date creationDate;
    private List<Ancillary> ancillaries;
    private String jobID;

    public long getId() {
        return id;
    }

    public String getName() {
    	return name;
    }
   
    public String getDatasetQName() {
		return datasetQName;
	}
    
    public void setDatasetQName(String datasetQName) {
		this.datasetQName = datasetQName;
	}
    
    public long getOwnerID() {
        return ownerID;
    }

    public long getSize() {
        return size;
    }

    public Status getStatus() {
        return status;
    }

    public String getUniqueName() {
        return uniqueName;
    }
    
    public int getRowsRead() {
		return rowsRead;
	}

	public int getRowsProcessed() {
		return rowsProcessed;
	}
	
	public Date getCreationDate(){
		return creationDate;
	}
	
	public List<Ancillary> getAncillaries() {
		return ancillaries;
	}

	public String getJobId() {
		return jobID;
	}
	
	public void setId(long id) {
        this.id = id;
    }
	
	public void setName(String name) {
		this.name = name;
	}

    public void setOwnerID(long ownerID) {
        this.ownerID = ownerID;
    }

    public void setSize(long size) {
        this.size = size;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }
    
	public void setRowsRead(int rowsRead) {
		this.rowsRead = rowsRead;
	}

	public void setRowsProcessed(int rowsProcessed) {
		this.rowsProcessed = rowsProcessed;
	}

	public void setCreationDate(Date creationDate){
		this.creationDate = creationDate;
	}
	
	public void setAncillaries(List<Ancillary> ancillaries) {
		this.ancillaries = ancillaries;
	}

	public void setJobId(String jobID) {
		this.jobID = jobID;
	}
	
    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<contribution>").append(newLine);
        sb.append(tab).append(indent).append("<id>").append(id).append("</id>").append(newLine);
        if (name != null) {
            sb.append(tab).append(indent).append("<name>").append(name).append("</name>").append(newLine);
        }
        if (datasetQName != null) {
        	sb.append(tab).append(indent).append("<dataset_qname>").append(datasetQName).append("</dataset_qname>").append(newLine);
        }
        if (uniqueName != null) {
            sb.append(tab).append(indent).append("<unique_name>").append(uniqueName).append("</unique_name>").append(newLine);
        }
        sb.append(tab).append(indent).append("<size>").append(size).append("</size>").append(newLine);
        sb.append(tab).append(indent).append("<owner_id>").append(ownerID).append("</owner_id>").append(newLine);
        if (status != null)
            sb.append(tab).append(indent).append("<status>").append(status).append("</status>").append(newLine);
        sb.append(tab).append(indent).append("<rows_read>").append(rowsRead).append("</rows_read>").append(newLine);
        sb.append(tab).append(indent).append("<rows_processed>").append(rowsProcessed).append("</rows_processed>").append(newLine);
        if(creationDate!=null){
        	//TODO: format the date!
        	sb.append(tab).append(indent).append("<creation_date>").append(creationDate).append("</creation_date>").append(newLine);
        }
    	sb.append(tab).append(indent).append("<ancillaries>").append(newLine);
        if(ancillaries!=null && ancillaries.size()!=0) {
        	for(Ancillary ancillary : ancillaries){
        		sb.append(ancillary.toString(newLine, tab, indent + tab + tab)).append(newLine);
        	}
        }
        sb.append(tab).append(indent).append("</ancillaries>").append(newLine);
        if (jobID != null) {
            sb.append(tab).append(indent).append("<job_id>").append(jobID).append("</job_id>").append(newLine);
        }
        sb.append(indent).append("</contribution>");
        return sb.toString();
    }

}
