package com.indicee.api.objects.dashboard;
import com.indicee.api.objects.IndiceeObject;

public class CachingMetadata  extends IndiceeObject {

	private static final long serialVersionUID = 8466754313081656846L;

	private Integer ttl;
    private Integer validityTime;
    private String scheduleCron;
    private Boolean isEnabled;
    private Boolean isPerUser;
    private Boolean isRefreshOnDataChange;
    private Boolean isRefreshPeriodically;
    
    public CachingMetadata() {
    }
    
    public CachingMetadata(Integer ttl, Integer validityTime, String scheduleCron,
    		Boolean isEnabled, Boolean isPerUser,
    		Boolean isRefreshOnDataChange, Boolean isRefreshPeriodically) {
		super();
		this.ttl = ttl;
		this.validityTime = validityTime;
		this.scheduleCron = scheduleCron;
		this.isEnabled = isEnabled;
		this.isPerUser = isPerUser;
		this.isRefreshOnDataChange = isRefreshOnDataChange;
		this.isRefreshPeriodically = isRefreshPeriodically;
	}

	public Integer getTtl() {
		return ttl;
	}

	public void setTtl(Integer ttl) {
		this.ttl = ttl;
	}

	public Integer getValidityTime() {
		return validityTime;
	}

	public void setValidityTime(Integer validityTime) {
		this.validityTime = validityTime;
	}

	public String getScheduleCron() {
		return scheduleCron;
	}

	public void setScheduleCron(String scheduleCron) {
		this.scheduleCron = scheduleCron;
	}

	public Boolean isEnabled() {
		return isEnabled;
	}

	public void setEnabled(Boolean isEnabled) {
		this.isEnabled = isEnabled;
	}

	public Boolean isPerUser() {
		return isPerUser;
	}

	public void setPerUser(Boolean isPerUser) {
		this.isPerUser = isPerUser;
	}

	public Boolean isRefreshOnDataChange() {
		return isRefreshOnDataChange;
	}

	public void setRefreshOnDataChange(Boolean isRefreshOnDataChange) {
		this.isRefreshOnDataChange = isRefreshOnDataChange;
	}

	public Boolean isRefreshPeriodically() {
		return isRefreshPeriodically;
	}

	public void setRefreshPeriodically(Boolean isRefreshPeriodically) {
		this.isRefreshPeriodically = isRefreshPeriodically;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		String indentAndTab = indent + tab;
		StringBuilder sb = new StringBuilder();
		sb.append(indent);
		sb.append("<caching_metadata>");
		sb.append(newLine);
		
		textElement(indentAndTab, newLine, "ttl", ttl, sb);

		textElement(indentAndTab, newLine, "schedule_cron", scheduleCron == null ? null : htmlEncode(scheduleCron), sb);

		textElement(indentAndTab, newLine, "is_enabled", isEnabled, sb);

		textElement(indentAndTab, newLine, "is_per_user", isPerUser, sb);

		textElement(indentAndTab, newLine, "is_refresh_on_data_change", isRefreshOnDataChange, sb);

		textElement(indentAndTab, newLine, "is_refresh_periodically", isRefreshPeriodically, sb);
		
		sb.append(indent);
		sb.append("</caching_metadata>");
		return sb.toString();
	}
}