package com.indicee.api.objects.dashboard;

import com.indicee.api.objects.IndiceeObject;

public class DashboardMetadata extends IndiceeObject{
	
	private static final long serialVersionUID = -5464698869682139836L;

	String qname;
	CachingMetadata cachingMetadata;
	
	public DashboardMetadata(String qname, CachingMetadata cachingMetadata) {
		this.qname = qname;
		this.cachingMetadata = cachingMetadata;
	}
	
	public void setCachingMetadata(CachingMetadata cachingMetadata) {
		this.cachingMetadata = cachingMetadata;
	}
	
	public CachingMetadata getCachingMetadata() {
		return cachingMetadata;
	}
	
	public void setQname(String qname) {
		this.qname = qname;
	}
	
	public String getQname() {
		return qname;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		String indentAndTab = indent + tab;
		StringBuilder sb = new StringBuilder();
		sb.append(indent);
		sb.append("<dashboard_metadata>");
		sb.append(newLine);

		sb.append(indentAndTab);
		sb.append("<qname>");
		sb.append(htmlEncode(qname));
		sb.append("</qname>");
		sb.append(newLine);
		
		sb.append(cachingMetadata.toString(newLine, tab, indentAndTab));
		sb.append(newLine);
		
		sb.append(indent);
		sb.append("</dashboard_metadata>");
		return sb.toString();
	}
}
