package com.indicee.api.objects.group;

import com.indicee.api.objects.IndiceeObject;

public class Group extends IndiceeObject {

	public enum GroupColor{
		Metal,Gold,Suede,Cherry,Peach,Orange,Olive,Jeans,Ocean;
	}
	
	private static final long serialVersionUID = -1648824707353837592L;
	
	private Long id;
	
	private String name;

	private String description;

	private Long ownerId;

	private Boolean deleted = Boolean.FALSE;

	private GroupColor color;

	private Boolean isPublic = Boolean.FALSE;
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Long getOwnerId() {
		return ownerId;
	}

	public void setOwnerId(Long ownerId) {
		this.ownerId = ownerId;
	}

	public Boolean getDeleted() {
		return deleted;
	}

	public void setDeleted(Boolean deleted) {
		this.deleted = deleted;
	}

	public GroupColor getColor() {
		return color;
	}

	public void setColor(GroupColor color) {
		this.color = color;
	}

	public Boolean getIsPublic() {
		return isPublic;
	}

	public void setIsPublic(Boolean isPublic) {
		this.isPublic = isPublic;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		sb.append("<group>");

		if(id!=null && id!=0L) {
			sb.append("<id>");
			sb.append(id);
			sb.append("</id>");
		}

		sb.append("<name>");
		sb.append(htmlEncode(name));
		sb.append("</name>");
		
		sb.append("<description>");
		sb.append(htmlEncode(description));
		sb.append("</description>");
		
		if(ownerId !=null){
			sb.append("<owner_id>");
			sb.append(ownerId);
			sb.append("</owner_id>");
		}
		
		sb.append("<color>");
		sb.append(color.ordinal());
		sb.append("</color>");
		
		sb.append("<deleted>");
		sb.append(deleted);
		sb.append("</deleted>");
		
		sb.append("<public>");
		sb.append(isPublic);
		sb.append("</public>");
		
		sb.append("</group>");
		return sb.toString();
	}

}
