package com.indicee.api.objects.identityprovider;

import com.indicee.api.objects.IndiceeObject;

public class IdentityProvider extends IndiceeObject {

	private static final long serialVersionUID = 6827549782562066447L;
	
	private String domain;
	private String idpUrl;
	private String idpCertificate;
	
	public IdentityProvider() {
	}
	
	public IdentityProvider(String domain, String idpUrl, String idpCertificate) {
		super();
		this.domain = domain;
		this.idpUrl = idpUrl;
		this.idpCertificate = idpCertificate;
	}

	public String getDomain() {
		return domain;
	}

	public String getIdpUrl() {
		return idpUrl;
	}

	public String getIdpCertificate() {
		return idpCertificate;
	}

	public void setDomain(String domain) {
		this.domain = domain;
	}

	public void setIdpUrl(String idpUrl) {
		this.idpUrl = idpUrl;
	}

	public void setIdpCertificate(String idpCertificate) {
		this.idpCertificate = idpCertificate;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<identity_provider>").append(newLine);
        sb.append(tab).append(indent).append("<domain>").append(htmlEncode(domain)).append("</domain>").append(newLine);
        sb.append(tab).append(indent).append("<provider_url>").append(htmlEncode(idpUrl)).append("</provider_url>").append(newLine);
        sb.append(tab).append(indent).append("<provider_certificate>").append(htmlEncode(idpCertificate)).append("</provider_certificate>").append(newLine);
        sb.append(indent).append("</identity_provider>");
        return sb.toString();
	}

}
