package com.indicee.api.objects.model;

import com.indicee.api.objects.IndiceeObject;

public class Attribute extends IndiceeObject {

    public enum Type {
        Boolean("Boolean"), Integer("Integer"), String("String"), Strings("[String]");
        public static Type get(String name) {
            for (Type type : Type.values()) {
                if (type.value.equals(name)) {
                    return type;
                }
            }
            return null;
        }

        private String value;

        private Type(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    private static final long serialVersionUID = -3985911853731623913L;
    private String name;
    private Type type;
    private String value;

    public Attribute() {

    }

    public Attribute(String name, Type type, String value) {
        this.value = value;
        this.type = type;
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public Type getType() {
        return type;
    }

    public String getValue() {
        return value;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setType(Type type) {
        this.type = type;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    public String toString(String newLine, String tab, String indent) {
    	if(type==null || value == null || name ==null)
    		return "";
    	else
    		return indent + "<attribute value=\"" + htmlEncode(value) + "\" type=\"" + type.value + "\" name=\"" + name + "\" />";
    }
}
