package com.indicee.api.objects.model;

import java.util.List;

public class Dataset extends StandardModelObject {

    private static final long serialVersionUID = -1442657156040269137L;

    private String description;
    private List<Table> tables;

    public Dataset() {

    }

    public Dataset(String name, String description) {
        setName(name);
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public List<Table> getTables() {
        return tables;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setTables(List<Table> tables) {
        this.tables = tables;
    }

    public String toMinimalString() {
        return toMinimalString("", "", "");
    }

    public String toMinimalString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<dataset>").append(newLine);
        sb.append(tab).append(indent).append("<name>").append(getName()).append("</name>").append(newLine);
        sb.append(tab).append(indent).append("<description>").append(description).append("</description>").append(
                newLine);
        sb.append(indent).append("</dataset>");
        return sb.toString();
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<dataset>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<description>").append(description).append("</description>").append(
                newLine);
        sb.append(tab).append(indent).append("<tables>").append(newLine);
        if (tables != null) {
            for (Table table : tables) {
                sb.append(table.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</tables>").append(newLine);
        sb.append(indent).append("</dataset>");
        return sb.toString();
    }
}
