package com.indicee.api.objects.model;

import java.util.List;

public class Entity extends StandardModelObject {

    private static final long serialVersionUID = -4774379199708403302L;
    private String caption;
    private List<String> keys;
    private List<String> properties;

    public Entity() {
    }

    public Entity(String name, String caption) {
        setName(name);
        this.caption = caption;
    }

    public String getCaption() {
        return caption;
    }

    public List<String> getKeys() {
        return keys;
    }

    public List<String> getProperties() {
        return properties;
    }

    public void setCaption(String caption) {
        this.caption = caption;
    }

    public void setKeys(List<String> keys) {
        this.keys = keys;
    }

    public void setProperties(List<String> properties) {
        this.properties = properties;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<entity>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<caption>").append(caption == null ?  "" : caption).append("</caption>").append(newLine);
        sb.append(tab).append(indent).append("<keys>").append(newLine);
        if (keys != null) {
            for (String key : keys) {
                sb.append(tab + tab).append(indent).append("<field>").append(key).append("</field>").append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</keys>").append(newLine);
        sb.append(tab).append(indent).append("<properties>").append(newLine);
        if (properties != null) {
            for (String property : properties) {
                sb.append(tab + tab).append(indent).append("<field>").append(property).append("</field>").append(
                        newLine);
            }
        }
        sb.append(tab).append(indent).append("</properties>").append(newLine);
        sb.append(indent).append("</entity>");
        return sb.toString();
    }
}
