package com.indicee.api.objects.model;

import java.util.ArrayList;
import java.util.List;

public class Hierarchy extends StandardModelObject {

    private static final long serialVersionUID = -7669801595819343522L;

    private List<String> entities;

    public Hierarchy() {
    	this.entities = new ArrayList<String>();
    }
    
    public List<String> getEntities() {
        return entities;
    }

    public void setEntities(List<String> entities) {
        this.entities = entities;
    }
    
    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<hierarchy>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<entities>").append(newLine);
        if (entities != null) {
            for (String entity : entities) {
                sb.append(tab + tab).append(indent).append("<entity>").append(entity).append("</entity>").append(
                        newLine);
            }
        }
        sb.append(tab).append(indent).append("</entities>").append(newLine);
        sb.append(indent).append("</hierarchy>");
        return sb.toString();
    }

}
