package com.indicee.api.objects.model;

import java.util.ArrayList;
import java.util.List;

public class Measure extends StandardModelObject {

    private static final long serialVersionUID = -4774379199708403302L;
    private List<String> entities;

    public Measure() {
    }

    public Measure(String name, String entity) {
        setName(name);
        this.entities = new ArrayList<String>();
        entities.add(entity);
    }

    public List<String> getEntities() {
        return entities;
    }

    public void setEntities(List<String> entities) {
        this.entities = entities;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<measure>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<entities>").append(newLine);
        if (entities != null) {
            for (String entity : entities) {
                sb.append(tab + tab).append(indent).append("<entity>").append(entity).append("</entity>").append(
                        newLine);
            }
        }
        sb.append(tab).append(indent).append("</entities>").append(newLine);
        sb.append(indent).append("</measure>");
        return sb.toString();
    }
}
