package com.indicee.api.objects.model;

import java.util.List;

import com.indicee.api.objects.model.binding.SourceTableBinding;

public class Model extends StandardModelObject {

    private static final long serialVersionUID = -8020418516383777635L;
    private List<SourceTableBinding> bindings;
    private List<Dataset> datasets;
    private List<Entity> entities;
    private List<Field> fields;
    private List<Hierarchy> hierarchies;
    private List<Measure> measures;
    private List<Relationship> relationships;
    private Integer owner_id;
    private Integer spaceID;
    private Integer version;

    public List<SourceTableBinding> getBindings() {
        return bindings;
    }

    public List<Dataset> getDatasets() {
        return datasets;
    }

    public List<Entity> getEntities() {
        return entities;
    }

    public List<Field> getFields() {
        return fields;
    }

    public List<Hierarchy> getHierarchies() {
        return hierarchies;
    }

    public List<Measure> getMeasures() {
        return measures;
    }

    public List<Relationship> getRelationships(){
    	return relationships;
    }
    
    public Integer getOwnerID() {
        return owner_id;
    }

    public int getSpaceID() {
        return spaceID;
    }

    public Integer getVersion() {
        return version;
    }

    public void setBindings(List<SourceTableBinding> bindings) {
        this.bindings = bindings;
    }

    public void setDatasets(List<Dataset> datasets) {
        this.datasets = datasets;
    }

    public void setEntities(List<Entity> entities) {
        this.entities = entities;
    }

    public void setFields(List<Field> fields) {
        this.fields = fields;
    }

    public void setHierarchies(List<Hierarchy> hierarchies) {
        this.hierarchies = hierarchies;
    }

    public void setMeasures(List<Measure> measures) {
        this.measures = measures;
    }
    
    public void setRelationships(List<Relationship> relationships) {
    	this.relationships = relationships;
    }

    public void setOwnerID(Integer ownerId) {
        owner_id = ownerId;
    }

    public void setSpaceID(int spaceID) {
        this.spaceID = spaceID;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<model>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<owner_id>").append(owner_id).append("</owner_id>").append(newLine);
        if (spaceID != null) {
            sb.append(tab).append(indent).append("<space_id>").append(spaceID).append("</space_id>").append(newLine);
        }
        sb.append(tab).append(indent).append("<version>").append(version).append("</version>").append(newLine);
        sb.append(tab).append(indent).append("<datasets>").append(newLine);
        if (datasets != null) {
            for (Dataset dataset : datasets) {
                sb.append(dataset.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</datasets>").append(newLine);
        sb.append(tab).append(indent).append("<fields>").append(newLine);
        if (fields != null) {
            for (Field field : fields) {
                sb.append(field.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</fields>").append(newLine);
        sb.append(tab).append(indent).append("<bindings>").append(newLine);
        if (bindings != null) {
            for (SourceTableBinding binding : bindings) {
                sb.append(binding.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</bindings>").append(newLine);
        sb.append(tab).append(indent).append("<entities>").append(newLine);
        if (entities != null) {
            for (Entity entity : entities) {
                sb.append(entity.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</entities>").append(newLine);
        sb.append(tab).append(indent).append("<measures>").append(newLine);
        if (measures != null) {
            for (Measure measure : measures) {
                sb.append(measure.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</measures>").append(newLine);
        
        sb.append(tab).append(indent).append("<relationships>").append(newLine);
        if (relationships != null) {
            for (Relationship relationship : relationships) {
                sb.append(relationship.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</relationships>").append(newLine);
        
        sb.append(tab).append(indent).append("<hierarchies>").append(newLine);
        if (hierarchies != null) {
            for (Hierarchy hierarchy : hierarchies) {
                sb.append(hierarchy.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(tab).append(indent).append("</hierarchies>").append(newLine);
        sb.append(indent).append("</model>");
        return sb.toString();
    }

}
