package com.indicee.api.objects.model;


public class Relationship extends StandardModelObject {

	private static final long serialVersionUID = 1L;


	public enum Type {
		ONE_TO_ONE, ONE_TO_MANY, MANY_TO_ONE, MANY_TO_MANY
	}
	
	private String left;
	private String right;
	private Type type;
	
	public Relationship() {
	}
	
	@Deprecated
	public String getUuid() {
		return getUUID();
	}

	@Deprecated
	public void setUuid(String uuid) {
		setUUID(uuid);
	}
	
	public String getLeftQName() {
		return left;
	}

	public void setLeftQName(String left) {
		this.left = left;
	}

	public String getRightQName() {
		return right;
	}

	public void setRightQName(String right) {
		this.right = right;
	}

	public Type getType() {
		return type;
	}

	public void setType(Type type) {
		this.type = type;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		if (left == null || right == null || type == null) {
			throw new IllegalStateException();
		}
		StringBuilder sb = new StringBuilder();
		sb.append("<relationship>").append(newLine);
		sb.append(printStandardEntities(newLine, tab, indent+tab));

		sb.append(tab).append("<left_entity>").append(left).append("</left_entity>").append(newLine);
		sb.append(tab).append("<relationship>").append(type).append("</relationship>").append(newLine);
		sb.append(tab).append("<right_entity>").append(right).append("</right_entity>").append(newLine);
		sb.append("</relationship>");
		return sb.toString();
	}



}
