package com.indicee.api.objects.model;

import java.util.List;

public class SourceField extends StandardModelObject {

    private static final long serialVersionUID = -6844014435807812396L;
    String dataFormat;
    DataType dataType;

    public SourceField() {
    }

    public SourceField(String name, List<Attribute> attributes, DataType dataType) {
        this(name, attributes, dataType, null);
    }

    public SourceField(String name, List<Attribute> attributes, DataType dataType, String dataFormat) {
        setName(name);
        setAttributes(attributes);
        this.dataType = dataType;
        this.dataFormat = dataFormat;
    }

    public String getDataFormat() {
        return dataFormat;
    }

    public DataType getDataType() {
        return dataType;
    }

    public void setDataFormat(String dataFormat) {
        this.dataFormat = dataFormat;
    }

    public void setDataType(DataType dataType) {
        this.dataType = dataType;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<source_field>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<data_type>").append(dataType).append("</data_type>").append(newLine);
        sb.append(tab).append(indent).append("<data_format>").append(dataFormat == null ? "" : dataFormat).append("</data_format>").append(
                newLine);
        sb.append(indent).append("</source_field>");
        return sb.toString();
    }
}
