package com.indicee.api.objects.model;

import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public abstract class StandardModelObject extends IndiceeObject {

    private static final long serialVersionUID = -2702932753867612092L;
    private List<Attribute> attributes;
    private String name;
    private String qname;
    private String uuid;
    
    public Attribute getAttribute(String key){
    	if(attributes!=null){
    		for(Attribute attr: attributes){
    			if(attr.getName().equals(key)){
    				return attr;
    			}
    		}
    		return null;
    	}else{
    		return null;
    	}
    }
    
    public List<Attribute> getAttributes() {
        return attributes;
    }

    public String getName() {
        return name;
    }

    public String getQName() {
        return qname;
    }

    public String getUUID() {
        return uuid;
    }

    protected String printStandardEntities(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        if (uuid != null)
            sb.append(indent).append("<uuid>").append(uuid).append("</uuid>").append(newLine);
        if (name != null)
            sb.append(indent).append("<name>").append(htmlEncode(name)).append("</name>").append(newLine);
        if (qname != null)
            sb.append(indent).append("<qname>").append(qname).append("</qname>").append(newLine);
        sb.append(indent).append("<attributes>").append(newLine);
        if (attributes != null)
            for (Attribute attribute : attributes) {
                sb.append(attribute.toString(newLine, tab, indent + tab)).append(newLine);
            }
        sb.append(indent).append("</attributes>").append(newLine);
        return sb.toString();
    }

    public void setAttributes(List<Attribute> attributes) {
        this.attributes = attributes;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setQName(String qname) {
        this.qname = qname;
    }

    public void setUUID(String uuid) {
        this.uuid = uuid;
    }
}
