package com.indicee.api.objects.model;

import java.util.List;

public class Table extends StandardModelObject {

    private static final long serialVersionUID = -5306408285354009101L;
    boolean rowDataFilter;
    boolean rowEndFilter;
    private List<SourceField> sourceFields;

    public Table() {
    }

    public Table(String name, List<Attribute> attributes, List<SourceField> sourceFields) {
        setName(name);
        setAttributes(attributes);
        this.sourceFields = sourceFields;
    }

    public boolean getRowDataFilter() {
        return rowDataFilter;
    }

    public boolean getRowEndFilter() {
        return rowEndFilter;
    }

    public List<SourceField> getSourceFields() {
        return sourceFields;
    }

    public void setRowDataFilter(boolean rowDataFilter) {
        this.rowDataFilter = rowDataFilter;
    }

    public void setRowEndFilter(boolean rowEndFilter) {
        this.rowEndFilter = rowEndFilter;
    }

    public void setSourceFields(List<SourceField> sourceFields) {
        this.sourceFields = sourceFields;
    }

    @Override
    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<table>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<source_fields>").append(newLine);
        if (sourceFields != null) {
	        for (SourceField sourceField : sourceFields) {
	            sb.append(sourceField.toString(newLine, tab, indent + tab + tab)).append(newLine);
	        }
        }
        sb.append(tab).append(indent).append("</source_fields>").append(newLine);
        sb.append(tab).append(indent).append("<row_data_filter>").append(rowDataFilter).append("</row_data_filter>")
                .append(newLine);
        sb.append(tab).append(indent).append("<row_end_filter>").append(rowEndFilter).append("</row_end_filter>")
                .append(newLine);
        sb.append(indent).append("</table>");
        return sb.toString();
    }

}
