package com.indicee.api.objects.model.binding;

import com.indicee.api.objects.model.DataType;
import com.indicee.api.objects.model.StandardModelObject;

public class Projection extends StandardModelObject {

    private static final long serialVersionUID = -7818982406552774618L;
    private DataType dataType;
    private String formula;

    public Projection() {
    }

    public Projection(String name, DataType dataType, String formula) {
        setName(name);
        this.dataType = dataType;
        this.formula = formula;
    }

    public DataType getDataType() {
        return dataType;
    }

    public String getFormula() {
        return formula;
    }

    public void setDataType(DataType dataType) {
        this.dataType = dataType;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<projection>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        if (formula != null) {
            if (formula.contains("\n")) {
                sb.append(tab).append(indent).append("<formula>").append(newLine);
                sb.append(tab + tab + indent).append(htmlEncode(formula)).append(newLine);
                sb.append(tab).append(indent).append("</formula>").append(newLine);
            } else {
                sb.append(tab).append(indent).append("<formula>").append(htmlEncode(formula)).append("</formula>").append(newLine);
            }
        }
        if (dataType != null) {
            sb.append(tab).append(indent).append("<data_type>").append(dataType).append("</data_type>").append(
                    newLine);
        }
        sb.append(indent).append("</projection>");
        return sb.toString();
    }
}
