package com.indicee.api.objects.model.binding;

import java.util.List;

import com.indicee.api.objects.model.StandardModelObject;

public class SourceTableBinding extends StandardModelObject {

    private static final long serialVersionUID = 4330355663782318304L;
    private List<Mapping> mappings;
    private List<Projection> projections;

    public SourceTableBinding() {

    }

    public SourceTableBinding(String name) {
        setName(name);
    }

    public List<Mapping> getMappings() {
        return mappings;
    }

    public List<Projection> getProjections() {
        return projections;
    }

    public void setMappings(List<Mapping> mappings) {
        this.mappings = mappings;
    }

    public void setProjections(List<Projection> projections) {
        this.projections = projections;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<source_table_binding>").append(newLine);
        sb.append(printStandardEntities(newLine, tab, indent + tab));
        sb.append(tab).append(indent).append("<projections>").append(newLine);
        if (projections != null)
            for (Projection projection : projections) {
                sb.append(projection.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        sb.append(tab).append(indent).append("</projections>").append(newLine);
        sb.append(tab).append(indent).append("<mappings>").append(newLine);
        if (mappings != null)
            for (Mapping mapping : mappings) {
                sb.append(mapping.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        sb.append(tab).append(indent).append("</mappings>").append(newLine);
        sb.append(indent).append("</source_table_binding>");
        return sb.toString();
    }

}
