package com.indicee.api.objects.report;

import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Column extends IndiceeObject {

    private static final long serialVersionUID = 3505611724505944273L;
    private String name;
    private List<Column> subColumns;
    private String value;

    public String getName() {
        return name;
    }

    public List<Column> getSubColumns() {
        return subColumns;
    }

    public String getValue() {
        return value;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setSubColumns(List<Column> subColumns) {
        this.subColumns = subColumns;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<column>").append(newLine);
        if (value != null) {
            sb.append(tab).append(indent).append("<value>").append(htmlEncode(value)).append("</value>").append(newLine);
        }
        if (name != null) {
            sb.append(tab).append(indent).append("<name>").append(name).append("</name>").append(newLine);
        }
        if (subColumns != null && !subColumns.isEmpty()) {
            sb.append(tab).append(indent).append("<sub>").append(newLine);
            for (Column column : subColumns) {
                sb.append(column.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(tab).append(indent).append("</sub>").append(newLine);
        }
        sb.append(indent).append("</column>");
        return sb.toString();
    }

}
