package com.indicee.api.objects.report;

import java.io.Serializable;

import com.indicee.api.objects.IndiceeObject;

public class Metadata extends IndiceeObject implements Serializable, Cloneable {

	private static final long serialVersionUID = 280237584535232464L;

	private String key;
	private String value;

	public Metadata() {
	}

	public Metadata(Metadata metadata) {
		this.key = metadata.getKey();
		this.value = metadata.getValue();
	}

	public Metadata(String key, String value) {
		this.key = key;
		this.value = value;
	}

	public Metadata clone() {
		return new Metadata(this);
	}

	public String getKey() {
		return key;
	}

	public String getValue() {
		return value;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public void setValue(String value) {
		this.value = value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((key == null) ? 0 : key.hashCode());
		result = prime * result + ((value == null) ? 0 : value.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Metadata other = (Metadata) obj;
		if (key == null) {
			if (other.key != null)
				return false;
		} else if (!key.equals(other.key))
			return false;
		if (value == null) {
			if (other.value != null)
				return false;
		} else if (!value.equals(other.value))
			return false;
		return true;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		return indent + "<entry key=\"" + key + "\" value=\"" + htmlEncode(value) + "\" />";
	}
}
