package com.indicee.api.objects.report;

import java.util.ArrayList;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Metadatas extends IndiceeObject {

    private static final long serialVersionUID = 5932403502838324234L;
    private List<Metadata> groups;
    private List<Metadata> measures;

    public Metadatas() {
    }

    public Metadatas(Metadatas metadatas) {
        if (metadatas.getGroups() != null) {
            groups = new ArrayList<Metadata>();
            for (Metadata group : metadatas.getGroups()) {
                groups.add(group.clone());
            }
        }
        if (metadatas.getMeasures() != null) {
            measures = new ArrayList<Metadata>();
            for (Metadata measure : metadatas.getMeasures()) {
                measures.add(measure.clone());
            }
        }
    }

    public List<Metadata> getGroups() {
        return groups;
    }

    public List<Metadata> getMeasures() {
        return measures;
    }

    public void setGroups(List<Metadata> groups) {
        this.groups = groups;
    }

    public void setMeasures(List<Metadata> measures) {
        this.measures = measures;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(tab).append("<metadata>").append(newLine);
        sb.append(tab + tab).append("<measures>").append(newLine);
        if (measures != null) {
            for (Metadata measure : measures) {
                sb.append(tab + tab + tab).append(measure).append(newLine);
            }
        }
        sb.append(tab + tab).append("</measures>").append(newLine);
        sb.append(tab + tab).append("<groups>").append(newLine);
        if (groups != null) {
            for (Metadata group : groups) {
                sb.append(tab + tab + tab).append(group).append(newLine);
            }
        }
        sb.append(tab + tab).append("</groups>").append(newLine);
        sb.append(tab).append("</metadata>");
        return sb.toString();
    }
}
