package com.indicee.api.objects.report;

import com.indicee.api.objects.IndiceeObject;

public class Property extends IndiceeObject {

	private static final long serialVersionUID = 1L;
	
	private String name;
	private String value;
	
	public Property() {
	}

	
	public Property(String name, String value) {
		this.name = name;
		this.value = value;
	}


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getValue() {
		return value;
	}


	public void setValue(String value) {
		this.value = value;
	}


	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		
		sb.append(indent);
		sb.append("<property name=\"");
		sb.append(htmlEncode(name));
		sb.append("\">");
		sb.append(newLine);
		sb.append(indent);
		sb.append(tab);
		sb.append("<value>");
		sb.append(htmlEncode(value));
		sb.append("</value>");
		sb.append(newLine);
		sb.append(indent);
		sb.append("</property>");
		
		return sb.toString();
	}

}
