package com.indicee.api.objects.report;

import java.io.Serializable;
import java.util.Date;

import com.indicee.api.objects.report.axes.Axes;
import com.indicee.api.objects.report.data.Data;

public class Results implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private Axes axes;
	private Data data;
	private long timeToGenerate;
	private Date generatedOn;
	
	public Results() {
	}
	
	public Results(Axes axes, Data data, Date generatedOn, long timeToGenerate) {
		super();
		this.axes = axes;
		this.data = data;
		this.setGeneratedOn(generatedOn);
		this.setTimeToGenerate(timeToGenerate);
	}

	public Axes getAxes() {
		return axes;
	}

	public void setAxes(Axes axes) {
		this.axes = axes;
	}

	public Data getData() {
		return data;
	}

	public void setData(Data data) {
		this.data = data;
	}
	
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		sb.append(indent).append("<results>").append(newLine);
		
		if (axes != null) {
			sb.append(axes.toString(newLine, tab, indent));
		}
		
		if (data != null) {
			sb.append(data.toString(newLine, tab, indent+tab));
		}
		
		sb.append(indent).append("</results>").append(newLine);
		
		return sb.toString();
	}
	
    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

	public long getTimeToGenerate() {
		return timeToGenerate;
	}

	public void setTimeToGenerate(long timeToGenerate) {
		this.timeToGenerate = timeToGenerate;
	}

	public Date getGeneratedOn() {
		return generatedOn;
	}

	public void setGeneratedOn(Date generatedOn) {
		this.generatedOn = generatedOn;
	}

}
