package com.indicee.api.objects.report.axes;

import java.util.ArrayList;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Axes extends IndiceeObject {

    private static final long serialVersionUID = -1082304863368358478L;
    private List<Axis> axes;

    public Axes() {
    }

    public Axes(Axes obj) {
        if (obj.getAxes() != null) {
            axes = new ArrayList<Axis>();
            for (Axis axis : obj.getAxes()) {
                axes.add(axis.clone());
            }
        }
    }

    public Axes(List<Axis> axes) {
        this.axes = axes;
    }

    public List<Axis> getAxes() {
        return axes;
    }

    public void setAxes(List<Axis> axes) {
        this.axes = axes;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        if (axes != null && !axes.isEmpty()) {
            sb.append(tab).append(indent).append("<axes>").append(newLine);
            for (Axis axis : axes) {
                sb.append(axis.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(tab).append(indent).append("</axes>").append(newLine);
        }
        return sb.toString();
    }

}
