package com.indicee.api.objects.report.axes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Axis extends IndiceeObject implements Serializable, Cloneable {

	private static final long serialVersionUID = -1136348447395899713L;

	private List<AxisColumn> columns;
	private long extent;

	public Axis() {
	}

	public Axis(Axis axis) {
		this.extent = axis.extent;
		if (axis.getColumns() != null) {
			columns = new ArrayList<AxisColumn>();
			for (AxisColumn column : axis.getColumns()) {
				columns.add(column.clone());
			}
		}
	}

	public Axis(long extent, List<AxisColumn> columns) {
		this.extent = extent;
		this.columns = columns;
	}

	public Axis clone() {
		return new Axis(this);
	}

	public List<AxisColumn> getColumns() {
		return columns;
	}

	public void setColumns(List<AxisColumn> columns) {
		this.columns = columns;
	}
	
	public long getExtent() {
		return extent;
	}
	
	public void setExtent(long extent) {
		this.extent = extent;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		sb.append(indent).append("<axis extent=\"").append(extent).append("\">").append(newLine);
		for (AxisColumn column : columns) {
			sb.append(column.toString(newLine, tab, indent + tab)).append(
					newLine);
		}
		sb.append(indent).append("</axis>");
		return sb.toString();
	}
}
