package com.indicee.api.objects.report.axes;

import java.util.List;

import com.indicee.api.objects.IndiceeObject;
import com.indicee.api.objects.report.Property;

public class AxisColumn extends IndiceeObject implements Cloneable {

	private static final long serialVersionUID = 3263703004977904711L;
	private String name;
	private List<AxisColumn> subColumns;
	private String type;
	private String value;
	
    private List<Property> properties;


	public AxisColumn() {

	}

	public AxisColumn(AxisColumn axisColumn) {

	}

	public AxisColumn clone() {
		return new AxisColumn(this);
	}

	public String getName() {
		return name;
	}

	public List<AxisColumn> getSubColumns() {
		return subColumns;
	}

	public String getType() {
		return type;
	}

	public String getValue() {
		return value;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setSubColumns(List<AxisColumn> subColumns) {
		this.subColumns = subColumns;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void setValue(String value) {
		this.value = value;
	}
	
	public List<Property> getProperties() {
		return properties;
	}
	
	public void setProperties(List<Property> properties) {
		this.properties = properties;
	}

	@Override
	public String toString(String newLine, String tab, String indent) {
		StringBuilder sb = new StringBuilder();
		sb.append(indent).append("<column type=\"" + type + "\">")
				.append(newLine);
		if (name != null) {
			sb.append(indent + tab).append("<name>" + name + "</name>")
					.append(newLine);
		}
		if (value != null) {
			sb.append(indent + tab).append("<value>" + htmlEncode(value) + "</value>")
					.append(newLine);
		}
		if (subColumns != null) {
			sb.append(indent + tab).append("<sub>").append(newLine);
			for (AxisColumn subColumn : subColumns) {
				sb.append(subColumn.toString(newLine, tab, indent + tab + tab))
						.append(newLine);
			}
			sb.append(indent + tab).append("</sub>").append(newLine);
		}
		
		if (properties != null) {
            sb.append(tab).append(indent).append("<properties>").append(newLine);
            for (Property property : properties) {
                sb.append(property.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(tab).append(indent).append("</properties>").append(newLine);
	    }
		 
		sb.append(indent).append("</column>");
		return sb.toString();
	}

}
