package com.indicee.api.objects.report.data;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class Data implements Serializable {

    private static final long serialVersionUID = -7943656981512035657L;
    private List<String> dataCells;
    private List<DataRow> reportDataRows;
    private Integer totalColumns;
    private Integer totalRows;

    public List<String> getReportDataCells() {
        return dataCells;
    }

    public List<DataRow> getReportDataRows() {
        return reportDataRows;
    }

    public int getTotalColumns() {
        return totalColumns;
    }

    public int getTotalRows() {
        return totalRows;
    }

    public void setReportDataCells(List<String> dataCells) {
        this.dataCells = dataCells;
    }

    public void setReportDataRows(List<DataRow> reportDataRows) {
        this.reportDataRows = reportDataRows;
    }

    public void setTotalColumns(int totalColumns) {
        this.totalColumns = totalColumns;
    }

    public void setTotalRows(int totalRows) {
        this.totalRows = totalRows;
    }

    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<data");
        if (totalColumns != null)
            sb.append(" cols=\"" + totalColumns + "\"").append(newLine);
        if (totalRows != null)
            sb.append(" rows=\"" + totalRows + "\"").append(newLine);
        sb.append(">").append(newLine);

        if (reportDataRows != null) {
        for (DataRow row : reportDataRows) {
            sb.append(row.toString(newLine, tab, indent + tab)).append(newLine);
            }
        }
        if (dataCells != null) {
            for (String cell : dataCells) {
                sb.append(indent + tab).append("<cell>" + IndiceeObject.htmlEncode(cell) + "</cell>").append(newLine);
            }
        }
        sb.append(indent).append("</data>").append(newLine);
        return sb.toString();
    }
}
