package com.indicee.api.objects.report.data;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;

public class DataRow implements Serializable {

    private static final long serialVersionUID = 2804700285721198269L;
    private List<String> cells;

    public List<String> getCells() {
        return cells;
    }

    public void setCells(List<String> cells) {
        this.cells = cells;
    }

    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    protected String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<row>").append(newLine);
        for (String cell : cells) {
            sb.append(indent).append(tab).append("<cell>").append(IndiceeObject.htmlEncode(cell)).append("</cell>").append(newLine);
        }
        sb.append(indent).append("</row>");
        return sb.toString();
    }
}
