package com.indicee.api.objects.report.view.attributes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class AttributesOrigin implements Serializable {
    private static final long serialVersionUID = 5002273132455463355L;
    private List<Attribute> attributes;
    private String name;

    public AttributesOrigin() {
    }

    public AttributesOrigin(AttributesOrigin AttributesOrigin) {
        name = AttributesOrigin.getName();
        if (AttributesOrigin.getReportAttributes() != null) {
            attributes = new ArrayList<Attribute>();
            for (Attribute attribute : AttributesOrigin.getReportAttributes()) {
                attributes.add(new Attribute(attribute));
            }
        }
    }

    public AttributesOrigin(String name, List<Attribute> attributes) {
        this.name = name;
        this.attributes = attributes;
    }

    public String getName() {
        return name;
    }

    public List<Attribute> getReportAttributes() {
        return attributes;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setReportAttributes(List<Attribute> reportAttributes) {
        this.attributes = reportAttributes;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<origin name=\"" + name + "\">").append(newLine);
        for (Attribute attribute : attributes) {
            sb.append(attribute.toString(newLine, tab, indent + tab)).append(newLine);
        }
        sb.append(indent).append("</origin>");
        return sb.toString();
    }
}
