package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;

public class LayerGroupSorting implements Serializable {

    private static final long serialVersionUID = 8914635484533704579L;
    private boolean ascending;
    private boolean sortByCaption;

    public LayerGroupSorting() {

    }

    public LayerGroupSorting(boolean ascending) {
        this.ascending = ascending;
    }

    public LayerGroupSorting(LayerGroupSorting groupSorting) {
        ascending = groupSorting.isAscending();
        sortByCaption = groupSorting.isSortByCaption();
    }

    public boolean isAscending() {
        return ascending;
    }

    public boolean isSortByCaption() {
        return sortByCaption;
    }

    public void setAscending(boolean ascending) {
        this.ascending = ascending;
    }

    public void setSortByCaption(boolean sortByCaption) {
        this.sortByCaption = sortByCaption;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append(
                "<groupsorting ascending=\"" + ascending + "\" sortbycaption=\"" + sortByCaption + "\"/>");
        return sb.toString();
    }
}
