package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class LayerQueryGrouping implements Serializable {

    private static final long serialVersionUID = 3774717634567206406L;
    private String entity;
    private List<QueryValue> properties;

    public LayerQueryGrouping() {
    }

    public LayerQueryGrouping(LayerQueryGrouping queryGrouping) {
        entity = queryGrouping.getEntity();
        if (queryGrouping.getProperties() != null) {
            properties = new ArrayList<QueryValue>();
            for (QueryValue property : queryGrouping.getProperties()) {
                properties.add(property.clone());
            }
        }
    }

    public LayerQueryGrouping(String entity) {
        this.entity = entity;
    }

    public String getEntity() {
        return entity;
    }

    public List<QueryValue> getProperties() {
        return properties;
    }

    public void setEntity(String entity) {
        this.entity = entity;
    }

    public void setProperties(List<QueryValue> properties) {
        this.properties = properties;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<querygrouping entity=\"" + entity + "\">").append(newLine);
        if (properties != null && !properties.isEmpty()) {
            sb.append(indent + tab).append("<properties>").append(newLine);
            for (QueryValue property : properties) {
                sb.append(property.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(indent + tab).append("</properties>").append(newLine);
        }
        sb.append(indent).append("</querygrouping>");
        return sb.toString();
    }
}
