package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public abstract class QueryValue implements Serializable {

    private static final long serialVersionUID = -8423097208076103369L;

    private String aggregator;
    private List<AttributesOrigin> attributes;

    public String getAggregator() {
        return aggregator;
    }

    public List<AttributesOrigin> getAttributes() {
        return attributes;
    }

    public void setAggregator(String aggregator) {
        this.aggregator = aggregator;
    }

    public void setAttributes(List<AttributesOrigin> attributes) {
        this.attributes = attributes;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<queryvalue ");
        
        writeAttributes(sb);
        
        if (aggregator != null) {
            sb.append(" aggregator=\"" + aggregator + "\"");
        }
        sb.append(">").append(newLine);
        
        writeElements(sb, newLine, tab, indent + tab);
        
        sb.append(indent + tab).append("<attributes>").append(newLine);
        if (attributes != null) {
            for (AttributesOrigin originAttribute : attributes) {
                sb.append(originAttribute.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
        }
        sb.append(indent + tab).append("</attributes>").append(newLine);
        sb.append(indent).append("</queryvalue>");
        return sb.toString();
    }
    
	public abstract QueryValue clone();
    
    protected abstract void writeAttributes(StringBuilder sb);
    
    protected void writeElements(StringBuilder sb, String newLine, String tab, String string) {
    	
	}
}
