package com.indicee.api.objects.report.view.axes;

import java.util.ArrayList;

import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class QueryValueModel extends QueryValue {

    private static final long serialVersionUID = -8423097208076103369L;

    private String entity;
    private String field;

    public QueryValueModel() {
    }

    public QueryValueModel(QueryValueModel queryValue) {
        field = queryValue.getField();
        entity = queryValue.getEntity();
        setAggregator(queryValue.getAggregator());
        if (queryValue.getAttributes() != null) {
            ArrayList<AttributesOrigin> attributes = new ArrayList<AttributesOrigin>();
            for (AttributesOrigin attribute : queryValue.getAttributes()) {
                attributes.add(new AttributesOrigin(attribute));
            }
            super.setAttributes(attributes);
        }
    }

    public QueryValueModel(String entity, String field) {
		this.entity = entity;
		this.field = field;
	}

	public QueryValueModel(String entity) {
		this.entity = entity;
	}

	public String getEntity() {
        return entity;
    }

    public String getField() {
        return field;
    }

    public void setEntity(String entity) {
        this.entity = entity;
    }

    public void setField(String field) {
        this.field = field;
    }
    
    @Override
    public QueryValue clone() {
    	return new QueryValueModel(this);
    }
    
    @Override
    protected void writeAttributes(StringBuilder sb) {
      if (field != null) {
    	  sb.append("field=\"" + field + "\" ");
      }
      sb.append("entity=\"" + entity + "\"");
    }
}
