package com.indicee.api.objects.report.view.axes;

import java.util.ArrayList;

import com.indicee.api.objects.IndiceeObject;
import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class QueryValueReport extends QueryValue {

	private static final long serialVersionUID = 1L;
	
	private String name;
    private String formula;
    
    public QueryValueReport() {
    	
    }

	public QueryValueReport(QueryValueReport queryValue) {
		name = queryValue.getName();
		formula = queryValue.getFormula();
		setAggregator(queryValue.getAggregator());
		if (queryValue.getAttributes() != null) {
			ArrayList<AttributesOrigin> attributes = new ArrayList<AttributesOrigin>();
			for (AttributesOrigin attribute : queryValue.getAttributes()) {
				attributes.add(new AttributesOrigin(attribute));
			}
			super.setAttributes(attributes);
		}
	}
    
    public String getName() {
		return name;
	}
    
    public void setName(String name) {
		this.name = name;
	}
    
    public String getFormula() {
		return formula;
	}
    
    public void setFormula(String formula) {
		this.formula = formula;
	}
    
    @Override
    public QueryValue clone() {
    	return new QueryValueReport(this);
    }
    
    @Override
    protected void writeAttributes(StringBuilder sb) {
	  	sb.append("name=\"" + name + "\"");
    }
    
    @Override
    protected void writeElements(StringBuilder sb, String newLine, String tab, String indent) {
    	sb.append(indent).append("<formula>");
    	if (formula != null) {
    		sb.append(IndiceeObject.htmlEncode(formula));
    	}
    	sb.append("</formula>").append(newLine);
	}

}
