package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class ValuesAxislayer extends Layer implements Serializable, Cloneable {

    private static final long serialVersionUID = -2469540269050340293L;
    private List<QueryValue> values;

    public ValuesAxislayer() {
    }

    public ValuesAxislayer(ValuesAxislayer valuesAxislayer) {
        if (valuesAxislayer.getValues() != null) {
            values = new ArrayList<QueryValue>();
            for (QueryValue groupFilter : valuesAxislayer.getValues()) {
                values.add(groupFilter.clone());
            }
        }
    }

    @Override
    public Layer clone() {
        return new ValuesAxislayer(this);
    }

    public List<QueryValue> getValues() {
        return values;
    }

    public void setValues(List<QueryValue> values) {
        this.values = values;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<valuesaxislayer>").append(newLine);
        sb.append(indent + tab).append("<values>").append(newLine);
        for (QueryValue value : values) {
            sb.append(value.toString(newLine, tab, indent + tab + tab)).append(newLine);
        }
        sb.append(indent + tab).append("</values>").append(newLine);
        sb.append(indent).append("</valuesaxislayer>");
        return sb.toString();
    }
}
