package com.indicee.api.objects.report.view.filter;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import com.indicee.api.objects.IndiceeObject;
import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public abstract class Filter extends IndiceeObject implements Serializable {

    private static final long serialVersionUID = -7215772648537058855L;

    private String entity;
    private String field;
    
    private boolean not;

    private boolean inclusive;

    protected ArrayList<AttributesOrigin> attributeOrigins;
    
    public Filter() {
    }

    public Filter(Filter filter) {
        this.entity = filter.entity;
        this.field = filter.field;
        this.inclusive = filter.inclusive;
    }

    public boolean getNot() {
    	return not;
    }
    
    public void setNot(boolean not) {
    	this.not = not;
    }
    
    public String getEntity() {
        return entity;
    }

    public String getField() {
        return field;
    }

    public boolean isInclusive() {
        return inclusive;
    }

    public void setEntity(String entity) {
        this.entity = entity;
    }

    public void setField(String field) {
        this.field = field;
    }

    public void setInclusive(boolean inclusive) {
        this.inclusive = inclusive;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }    
    
    public List<AttributesOrigin> getAttributeOrigins() {
		return attributeOrigins;
	}
    
    public void setAttributeOrigins(ArrayList<AttributesOrigin> attributes) {
		this.attributeOrigins = attributes;
	}

    @Override
    public abstract String toString(String newLine, String tab, String indent);

}
