package com.indicee.api.objects.report.view.filter;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class RelativeTimePeriodFilter extends Filter implements Serializable {

    private static final long serialVersionUID = -8866327616124680786L;
    private String calendar;
    private List<RelativeTimePeriod> relativeTimePeriods;

    public String getCalendar() {
        return calendar;
    }

    public List<RelativeTimePeriod> getRelativeTimePeriods() {
        return relativeTimePeriods;
    }

    public void setCalendar(String calendar) {
        this.calendar = calendar;
    }

    public void setRelativeTimePeriods(List<RelativeTimePeriod> relativeTimePeriods) {
        this.relativeTimePeriods = relativeTimePeriods;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<relativetimeperiodfilter field=\"" + getField() + "\"");
        
        if (calendar != null) {
        	sb.append(" calendar=\"" + calendar + "\"");
        }
        
        sb.append(" inclusive=\"" + isInclusive() + "\"");
        
        
        if (getEntity() != null && !getEntity().isEmpty()) {
            sb.append(" entity=\"" + getEntity() + "\"");
        }
        sb.append(">").append(newLine);
        sb.append(indent + tab).append("<relativetimeperiods>").append(newLine);
        for (RelativeTimePeriod relativeTimePeriod : relativeTimePeriods) {
            sb.append(relativeTimePeriod.toString(newLine, tab, indent + tab + tab)).append(newLine);
        }
        sb.append(indent + tab).append("</relativetimeperiods>").append(newLine);
        
        if (attributeOrigins != null) {
            sb.append(indent).append(tab).append("<attributes>").append(newLine);
            if (!attributeOrigins.isEmpty()) {
                for (AttributesOrigin attributeOrigin : attributeOrigins) {
                    sb.append(attributeOrigin.toString(newLine, tab, indent + tab + tab)).append(newLine);
                }
            }
            sb.append(indent).append(tab).append("</attributes>").append(newLine);
        }
        
        sb.append(indent).append("</relativetimeperiodfilter>");
        return sb.toString();
    }
}
