package com.indicee.api.parser;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;

import com.indicee.api.objects.model.Attribute;
import com.indicee.api.util.XmlHelper;

public class AttributeParser {

	public static Attribute parse(Element element) {
        Attribute attribute = new Attribute();
        attribute.setName(element.getAttribute("name"));
        attribute.setType(Attribute.Type.get(element.getAttribute("type")));
        attribute.setValue(element.getAttribute("value"));
        return attribute;
	}
	
	public static List<Attribute> parseList(Element element) {
		List<Element > children = XmlHelper.childElements(element);
		List<Attribute> attributes = new ArrayList<Attribute>(children.size());
		for (Element child : children) {
			Attribute attribute = parse(child);
			attributes.add(attribute);
		}
		
		return attributes;
	}
}
