package com.indicee.api.parser;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.collection.Collection;
import com.indicee.api.util.XmlHelper;

public class CollectionParser extends IndiceeParser {
	public static Collection createCollection(Document collectionDoc){
		Element collection = XmlHelper.getElements(collectionDoc.getElementsByTagName("collection"), "collection").get(0);
		return createCollection(collection);
	}

	
	public static List<Collection> createCollectionList(Document doc){
		List<Collection> collectionsList = new ArrayList<Collection>();
		List<Element> collections = XmlHelper.getElements(doc.getElementsByTagName("collection"), "collection");
		for(Element collection:collections){
			collectionsList.add(createCollection(collection));
		}
		return collectionsList;
	}
	
	private static Collection createCollection(Element collectionElement) {
		Collection collection= new Collection();
		
		if(XmlHelper.childText(collectionElement, "id") != null){
			collection.setId(Long.parseLong(XmlHelper.childText(collectionElement, "id")));
		}
		
		collection.setName(XmlHelper.childText(collectionElement, "name"));
		
		collection.setDescription(XmlHelper.childText(collectionElement, "description"));
		
		collection.setQname(XmlHelper.childText(collectionElement, "qname"));
		
		if(XmlHelper.childText(collectionElement, "ownerId")!=null){
			collection.setOwnerId(Long.parseLong(XmlHelper.childText(collectionElement, "ownerId")));
		}
		
		if(XmlHelper.childText(collectionElement, "deleted") != null){
			collection.setDeleted(Boolean.parseBoolean(XmlHelper.childText(collectionElement, "deleted")));
		}
		
		List<String> qnameList = new ArrayList<String>();
		List<Element> qnames = XmlHelper.getElements(collectionElement.getElementsByTagName("dataset"), "dataset");
			if(qnames!=null){
			for(Element qname : qnames){
				qnameList.add(qname.getTextContent());
			}
		}
			
		if (!qnameList.isEmpty()){
			collection.setDataSetQnames(qnameList);
		}
		
		return collection;
	}
}
