package com.indicee.api.parser;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.infospace.Infospace;
import com.indicee.api.util.XmlHelper;

public class InfospaceParser extends IndiceeParser {
	
	public static Infospace createInfospace(Document infoDoc){
		Element infospace = XmlHelper.getElements(infoDoc.getElementsByTagName("infospace"), "infospace").get(0);
		return createInfospace(infospace);
	}

	
	public static List<Infospace> createInfospaceList(Document doc){
		List<Infospace> infospacesList = new ArrayList<Infospace>();
		List<Element> infospaces = XmlHelper.getElements(doc.getElementsByTagName("infospace"), "infospace");
		for(Element infospace : infospaces) {
			infospacesList.add(createInfospace(infospace));
		}
		return infospacesList;
	}
	
	private static Infospace createInfospace(Element infospace) {
		Infospace space= new Infospace();
		space.setId(Long.parseLong(XmlHelper.childText(infospace, "id")));
		space.setOwnerId(Long.parseLong(XmlHelper.childText(infospace, "ownerId")));
		space.setVersion(XmlHelper.childText(infospace, "version"));
		space.setDescription(XmlHelper.childText(infospace, "description"));
		space.setName(XmlHelper.childText(infospace, "name"));
		return space;
	}
}
