package com.indicee.api.parser;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import com.indicee.api.objects.report.QueryRequest;

public class QueryRequestParser extends IndiceeParser {
	public static QueryRequest createQueryRequest(Document reportDocument) {
		return getQueryRequest(reportDocument.getDocumentElement());
	}

	private static QueryRequest getQueryRequest(Node reportNode) {
		QueryRequest request = new QueryRequest();
		for (int i = 0; i < reportNode.getChildNodes().getLength(); i++) {
			Node child = reportNode.getChildNodes().item(i);
			String nodeName = child.getNodeName();
			if (nodeName.equals("request_id")) {
				request.setRequestId(getString(child));
			} else if (nodeName.equals("status")) {
				request.setStatus(getString(child));
			}
		}
		return request;
	}

}
