/**
 * 
 */
package com.indicee.api.parser;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;

import com.indicee.api.objects.model.Relationship;
import com.indicee.api.objects.model.Relationship.Type;
import com.indicee.api.util.XmlHelper;

/**
 * @author thaggie
 *
 */
public class RelationshipParser {

	public static Relationship parseRelationship(Element element) {
		Relationship relationship = new Relationship();
		String uuid = XmlHelper.childText(element, "uuid");
		relationship.setUUID(uuid);
		String left= XmlHelper.childText(element, "left_entity");
		relationship.setLeftQName(left);
		String right= XmlHelper.childText(element, "right_entity");
		relationship.setRightQName(right);
		String typeString = XmlHelper.childText(element, "relationship");
		Type type = Type.valueOf(typeString);
		relationship.setType(type );
		
		Element child = XmlHelper.child(element, "attributes");
		if (child != null) {
			relationship.setAttributes(ModelParser.getAttributes(child.getChildNodes()));
		}
		return relationship;
	}

	public static List<Relationship> parseRelationships(Element element) {
		List<Element> relationshipElements = XmlHelper.childElements(element, "relationship");
		List<Relationship> relationships = new ArrayList<Relationship>(relationshipElements.size());
		for (Element relationshipElement : relationshipElements) {
			Relationship relationship = parseRelationship(relationshipElement);
			relationships.add(relationship);
		}
		return relationships;
	}
}
