package com.indicee.api.services.impl;

import org.w3c.dom.Document;

import com.indicee.api.connector.IndiceeAPIConnector;
import com.indicee.api.connector.exception.IndiceeAPIConnectorException;
import com.indicee.api.objects.Job;
import com.indicee.api.parser.JobParser;
import com.indicee.api.services.interfaces.JobService;

public class JobServiceImpl extends IndiceeAPIService implements JobService {

	private static final String JOBS_URL = "/api/jobs";

	protected JobServiceImpl(){
		super();
	}
	
	public JobServiceImpl(IndiceeAPIConnector connector){
		super(connector);
	}
	
    /**
     * @see com.indicee.api.services.interfaces.JobService#getJob(java.lang.String)
     */
    @Override
    public Job getJob(String jobId) throws IndiceeAPIConnectorException {
    	Document document = connector.makeGetCallRtnDocument(JOBS_URL + URL_SLASH + jobId);
    	return JobParser.createJob(document);
    }

	@Override
	protected IndiceeAPIService getInstance(IndiceeAPIConnector connector) {
		return new ContributionServiceImpl(connector);
	}
}
