package com.indicee.api.services.impl;

import java.util.HashMap;
import java.util.Map;

import com.indicee.api.connector.IndiceeAPIConnector;
import com.indicee.api.connector.exception.IndiceeAPIConnectorException;
import com.indicee.api.services.interfaces.ModelServiceV2;

public class ModelServiceV2Impl extends IndiceeAPIService  implements ModelServiceV2 {

	private static final String MODEL_URL = "/api/models";
    private static final String DATASETS_URL = MODEL_URL + "/datasets/v2";
    private static final String TURBO_URL = "/turbo";
    private static final String SET_URL = "/set";
    private static final String GET_URL = "/get";
	
	protected ModelServiceV2Impl() {
        super();
    }
	
	public ModelServiceV2Impl(IndiceeAPIConnector connector) {
		super(connector);
	}
	
	@Override
	public void setTurboMode(String qname, Boolean active) throws IndiceeAPIConnectorException {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("qname", qname);
		map.put("active", active);
		connector.makePostCallRtnString(DATASETS_URL + TURBO_URL + SET_URL + DOT_XML , map);
	}

	@Override
	public boolean getTurboMode(String qname) throws IndiceeAPIConnectorException {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("qname", qname);
		String result = connector.makeGetCallRtnString(DATASETS_URL + TURBO_URL + GET_URL + DOT_XML, map);
		return Boolean.parseBoolean(result);
	}

	@Override
	protected IndiceeAPIService getInstance(IndiceeAPIConnector connector) {
		return new ModelServiceV2Impl(connector);
	}

}
