package com.indicee.api.services.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Document;

import com.indicee.api.connector.IndiceeAPIConnector;
import com.indicee.api.connector.exception.IndiceeAPIConnectorException;
import com.indicee.api.objects.ViewWindow;
import com.indicee.api.objects.report.Column;
import com.indicee.api.objects.report.Report;
import com.indicee.api.objects.report.data.Data;
import com.indicee.api.objects.report.view.View;
import com.indicee.api.objects.report.view.axes.GroupingAxisLayer;
import com.indicee.api.objects.report.view.filter.Filter;
import com.indicee.api.parser.ReportParser;
import com.indicee.api.services.interfaces.ReportService;
import com.indicee.api.services.interfaces.ReportServiceV2;

/**
 * This is the implementation of the {@link ReportService}
 * 
 * @author victork
 * 
 */
@Deprecated
public class ReportServiceV2Impl extends IndiceeAPIService implements ReportServiceV2 {

    private static final String MAX_REPORTS = "?rpp=1000";
	private static final String DATA_URL = "/data";
    private static final String HEADER_URL = "/header";
    private static final String REPORT_URL = API_URL + "/reports/v2";
    private static final String REPORT_URL_OLD = "/api/reports";

    protected ReportServiceV2Impl() {
        super();
    }

    /**
     * Creates a new report service.
     * 
     * @param connector
     *            The {@link IndiceeAPIConnector} to use.
     */
    public ReportServiceV2Impl(IndiceeAPIConnector connector) {
        super(connector);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report createReport(String name) throws IndiceeAPIConnectorException {
        return createReport(name, null);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report createReport(String name, View view) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("name", name);
        if (view != null) {
            params.put("view", view.toFormatedString());
        }
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL + CREATE_URL, params);
        return ReportParser.createReport(reportDocument);
    }

    @Deprecated
    @Override
    public Report deleteReport(int reportID) throws IndiceeAPIConnectorException {
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL_OLD + URL_SLASH + reportID + DELETE_URL);
        return ReportParser.createReport(reportDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report deleteReport(String qname) throws IndiceeAPIConnectorException {
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL + DELETE_URL + URL_QUERY_PARAM_START
                + "qname=" + urlEncode(qname));
        return ReportParser.createReport(reportDocument);
    }

    @Override
    protected IndiceeAPIService getInstance(IndiceeAPIConnector connector) {
        return new ReportServiceV2Impl(connector);
    }

    @Deprecated
    @Override
    public Report getReport(int reportID) throws IndiceeAPIConnectorException {
        return getReport(reportID, new ViewWindow());
    }

    @Deprecated
    @Override
    public Report getReport(int reportID, List<Filter> fieldFilters) throws IndiceeAPIConnectorException {
        return getReport(reportID, fieldFilters, new ViewWindow());
    }

    @Deprecated
    @Override
    public Report getReport(int id, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers)
            throws IndiceeAPIConnectorException {
        return getReport(id, fieldFilters, groupingAxisLayers, new ViewWindow());
    }

    @Deprecated
    @Override
    public Report getReport(int reportID, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers,
            ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        View reportView = getReportView(reportID);
        reportView.getFieldFilters().addAll(fieldFilters);
        reportView.getReportViewAxes().get(0).getLayers().addAll(groupingAxisLayers);
        return getReport(reportID, reportView, viewWindow);
    }

    @Deprecated
    @Override
    public Report getReport(int reportID, List<Filter> fieldFilters, ViewWindow viewWindow)
            throws IndiceeAPIConnectorException {
        View reportView = getReportView(reportID);
        reportView.getFieldFilters().addAll(fieldFilters);
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("view", reportView.toFormatedString());
        params.put("window", viewWindow);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL_OLD + URL_SLASH + reportID, params);
        return ReportParser.createReport(reportDocument);
    }

    @Deprecated
    @Override
    public Report getReport(int reportID, View view, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("view", view.toFormatedString());
        params.put("window", viewWindow);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL_OLD + URL_SLASH + reportID, params);
        return ReportParser.createReport(reportDocument);
    }

    @Deprecated
    @Override
    public Report getReport(int reportID, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Document reportDocument = connector.makeGetCallRtnDocument(REPORT_URL_OLD + URL_SLASH + reportID
                + URL_QUERY_PARAM_START + "window=" + viewWindow);
        return ReportParser.createReport(reportDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report getReport(String qname) throws IndiceeAPIConnectorException {
        return getReport(qname, new ViewWindow());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report getReport(String qname, List<Filter> fieldFilters) throws IndiceeAPIConnectorException {
        return getReport(qname, fieldFilters, new ViewWindow());
    }

    @Override
    public Report getReport(String qname, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers)
            throws IndiceeAPIConnectorException {
        return getReport(qname, fieldFilters, groupingAxisLayers, new ViewWindow());
    }

    @Override
    public Report getReport(String qname, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers,
            ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        View reportView = getReportView(qname);
        reportView.getFieldFilters().addAll(fieldFilters);
        reportView.getReportViewAxes().get(0).getLayers().addAll(groupingAxisLayers);
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("view", reportView.toFormatedString());
        params.put("window", viewWindow);
        params.put("qname", qname);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL, params);
        return ReportParser.createReport(reportDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report getReport(String qname, List<Filter> fieldFilters, ViewWindow viewWindow)
            throws IndiceeAPIConnectorException {
        View reportView = getReportView(qname);
        reportView.getFieldFilters().addAll(fieldFilters);
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("view", reportView.toFormatedString());
        params.put("window", viewWindow);
        params.put("qname", qname);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL, params);
        return ReportParser.createReport(reportDocument);
    }

    @Override
    public Report getReport(String qname, View view, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("view", view.toFormatedString());
        params.put("window", viewWindow);
        params.put("qname", qname);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL, params);
        return ReportParser.createReport(reportDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Report getReport(String qname, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("window", viewWindow);
        params.put("qname", qname);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL, params);
        return ReportParser.createReport(reportDocument);
    }

    @Override
    public Data getReportData(String qname) throws IndiceeAPIConnectorException {
        return getReportData(qname, new ViewWindow());
    }

    @Override
    public Data getReportData(String qname, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        
//        ViewWindow fixedWindow = new ViewWindow(viewWindow.getRowStart(),viewWindow.getRowStart()+viewWindow.getNumRows(),
//        		viewWindow.getColumnStart(),viewWindow.getColumnStart()+viewWindow.getNumColumns());
        params.put("window", viewWindow);
        params.put("qname", qname);
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL + DATA_URL, params);
        return ReportParser.createReportData(reportDocument);
    }

    @Override
    public Data getReportData(View reportView) throws IndiceeAPIConnectorException {
        return getReportData(reportView, new ViewWindow());
    }

    @Override
    public Data getReportData(View reportView, ViewWindow viewWindow) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("window", viewWindow);
        params.put("view", reportView.toString());
        Document reportDocument = connector.makePostCallRtnDocument(REPORT_URL + DATA_URL, params);
        return ReportParser.createReportData(reportDocument);
    }

    @Override
    public List<Column> getReportHeader(String qname) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("qname", "iqn.2://indicee.com/3/0/question/dfdaa7e8-b4f4-476c-a1a7-43a46063eb02");
        Document headerDocument = connector.makeGetCallRtnDocument(REPORT_URL + HEADER_URL, params);
        return ReportParser.createReportHeader(headerDocument);
    }

    @Deprecated
    @Override
    public View getReportView(int reportID) throws IndiceeAPIConnectorException {
        Document reportViewDocument = connector
                .makeGetCallRtnDocument(REPORT_URL_OLD + URL_SLASH + reportID + VIEW_URL);
        return ReportParser.createReportView(reportViewDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public View getReportView(String qname) throws IndiceeAPIConnectorException {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("qname", qname);
        Document reportViewDocument = connector.makeGetCallRtnDocument(REPORT_URL + VIEW_URL, params);
        return ReportParser.createReportView(reportViewDocument);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Report> listReports() throws IndiceeAPIConnectorException {
        Document reportDocument = connector.makeGetCallRtnDocument(REPORT_URL + LIST_URL + MAX_REPORTS);
        return ReportParser.createReports(reportDocument);
    }
}
