package com.indicee.api.services.interfaces;

import com.indicee.api.connector.exception.IndiceeAPIConnectorException;
import com.indicee.api.objects.Job;

public interface JobService {
	
	/**
	 * Retrieve a running job by ID, this should be used after creating a contribution or setting turbo on/off to detect 
	 * whether or not it was successful  by polling.
	 * @param jobId - Comes from: contribution.getJobId() or the result of setTurbo
	 * @return Job - Information about the job that's running to upload the contribution or setTrubo
	 * @throws IndiceeAPIConnectorException 
	 */
	public Job getJob(String jobId) throws IndiceeAPIConnectorException;
}
