package com.indicee.api.services.interfaces;

import java.util.List;

import com.indicee.api.connector.exception.IndiceeAPIConnectorException;
import com.indicee.api.objects.ViewWindow;
import com.indicee.api.objects.report.Column;
import com.indicee.api.objects.report.Report;
import com.indicee.api.objects.report.data.Data;
import com.indicee.api.objects.report.view.View;
import com.indicee.api.objects.report.view.axes.GroupingAxisLayer;
import com.indicee.api.objects.report.view.filter.Filter;

/**
 * The report service is use to create, and view reports from Indicee.
 * 
 * @author victork
 * 
 */
@Deprecated
public interface ReportServiceV2 {

    /**
     * Creates a report with the given name. The default {@link ViewWindow} is
     * used.
     * 
     * @param name
     *            The name of the report to use.
     * @return The report ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report createReport(String name) throws IndiceeAPIConnectorException;

    /**
     * Creates a report with the given name and view.
     * 
     * @param name
     *            The name of the report to use.
     * @param view
     *            The view for the report.
     * @return The report ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report createReport(String name, View view) throws IndiceeAPIConnectorException;

    /**
     * Deletes the report give the report id.
     * 
     * @param reportID
     *            The ID of the report to delete.
     * @return The report ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public Report deleteReport(int reportID) throws IndiceeAPIConnectorException;

    /**
     * Deletes the report give the report id.
     * 
     * @param qname
     *            The qname of the report to delete.
     * @return The report.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report deleteReport(String qname) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id. The dedfault {@link ViewWindow} is
     * used.
     * 
     * @param reportID
     *            The ID of the report to use.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public Report getReport(int reportID) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param reportID
     *            The ID of the report to use.
     * @param fieldFilters
     *            A list of field filters to add to the report.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public Report getReport(int reportID, List<Filter> fieldFilters) throws IndiceeAPIConnectorException;

    @Deprecated
    Report getReport(int id, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers)
            throws IndiceeAPIConnectorException;

    @Deprecated
    public Report getReport(int id, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers,
            ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param reportID
     *            The ID of the report to use.
     * @param fieldFilters
     *            A list of field filters to add to the report.
     * @param viewWindow
     *            The view window for the data to return.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public Report getReport(int reportID, List<Filter> fieldFilters, ViewWindow viewWindow)
            throws IndiceeAPIConnectorException;

    @Deprecated
    public Report getReport(int reportID, View view, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param reportID
     *            The ID of the report to use.
     * @param viewWindow
     *            The view window for the data to return.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public Report getReport(int reportID, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id. The dedfault {@link ViewWindow} is
     * used.
     * 
     * @param qname
     *            The qname of the report to use.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report getReport(String qname) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param qname
     *            The qname of the report to use.
     * @param fieldFilters
     *            A list of field filters to add to the report.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report getReport(String qname, List<Filter> fieldFilters) throws IndiceeAPIConnectorException;

    Report getReport(String qname, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers)
            throws IndiceeAPIConnectorException;

    public Report getReport(String qname, List<Filter> fieldFilters, List<GroupingAxisLayer> groupingAxisLayers,
            ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param qname
     *            The qname of the report to use.
     * @param fieldFilters
     *            A list of field filters to add to the report.
     * @param viewWindow
     *            The view window for the data to return.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report getReport(String qname, List<Filter> fieldFilters, ViewWindow viewWindow)
            throws IndiceeAPIConnectorException;

    public Report getReport(String qname, View view, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    /**
     * Returns the report give the report id
     * 
     * @param qname
     *            The qname of the report to use.
     * @param viewWindow
     *            The view window for the data to return.
     * @return The report specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public Report getReport(String qname, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    public Data getReportData(String qname) throws IndiceeAPIConnectorException;

    public Data getReportData(String qname, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    public Data getReportData(View reportView) throws IndiceeAPIConnectorException;

    public Data getReportData(View reportView, ViewWindow viewWindow) throws IndiceeAPIConnectorException;

    public List<Column> getReportHeader(String qname) throws IndiceeAPIConnectorException;

    /**
     * Returns the report view given the report id.
     * 
     * @param reportID
     *            The ID of the report.
     * @return The report view specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    @Deprecated
    public View getReportView(int reportID) throws IndiceeAPIConnectorException;

    /**
     * Returns the report view given the report id.
     * 
     * @param qname
     *            The qname of the report.
     * @return The report view specified by the given ID.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public View getReportView(String qname) throws IndiceeAPIConnectorException;

    /**
     * Returns the list of reports
     * 
     * @return The list of reports.
     * @throws IndiceeAPIConnectorException
     *             Thrown if there is a problem connecting to Indicee, or the
     *             server returned an error.
     */
    public List<Report> listReports() throws IndiceeAPIConnectorException;
}
