package com.indicee.api.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.account.Attribute;

public class AccountAttributeXml {
	
	public static final String TAG = "account_attribute";
	
	private static enum Tag {
		value,
		hierarchical,
		name
	}
	
	public static final ToXml<Attribute> toXml = new ToXml<Attribute>() {

		@Override
		public Element call(Document document, Attribute attribute) {
			Element element = createElement(document, TAG);
			setAttribute(element, Tag.name,         attribute.getName());
			setAttribute(element, Tag.value,        attribute.getValue());
			setAttribute(element, Tag.hierarchical, attribute.getHierarchy());
			return element;
		}
		
	};
	
	protected static final FromXml<Attribute> fromXml = new FromXml<Attribute>() {
		
		@Override
		public Attribute call(Element element) {
			String name = getText(element, Tag.name);
			String value = getText(element, Tag.value);
			boolean hierarchical = getBoolean(element, Tag.hierarchical);
			return new Attribute(name, value, hierarchical);
		}
	};
}
