package com.indicee.api.xml;

import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.report.view.attributes.Attribute;
import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class AttributesOriginXml {

	public static final String TAG = "origin";
	
	private enum Tag {
		name
	}

	public static final ToXml<AttributesOrigin> toXml = new ToXml<AttributesOrigin>() {

		@Override
		public Element call(Document document, AttributesOrigin origin) {
			Element originElement = createElement(document, TAG);
			setAttribute(originElement, Tag.name, origin.getName());
			
			ViewAttributeXml.toXml.append(originElement, origin.getReportAttributes());

			return originElement;
		}
		
	};
	
	public static final FromXml<AttributesOrigin> fromXml = new FromXml<AttributesOrigin>() {
		@Override
		public AttributesOrigin call(Element element) {
			AttributesOrigin origin = new AttributesOrigin();
			origin.setName(getText(element, Tag.name));
			
			List<Attribute> attributes = ViewAttributeXml.fromXml.toList(element);
			origin.setReportAttributes(attributes);
			
			return origin;
		}
	};
}
