package com.indicee.api.xml;

import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.report.axes.Axis;
import com.indicee.api.objects.report.axes.AxisColumn;

public class AxisXml {
	public static final String TAG = "axis";

	
	public static final ToXml<Axis> toXml = new ToXml<Axis>() {
		@Override
		public Element call(Document document, Axis axis) {
			Element axisElement = createElement(document, TAG);
			List<AxisColumn> columns = axis.getColumns();
			AxisColumnXml.toXml.append(axisElement, columns);
			return axisElement;
		}
	};
	
	public static final FromXml<Axis> fromXml = new FromXml<Axis>() {
		@Override
		public Axis call(Element element) {
			Axis axis = new Axis();
			List<AxisColumn> columns = AxisColumnXml.fromXml.toList(element);
			axis.setColumns(columns);
			return axis;
		}
	};
}