package com.indicee.api.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.report.view.filter.FieldFilterValue;

public class FieldFilterValueXml {
	public static final String TAG = "value";
	
	public static final ToXml<FieldFilterValue> toXml = new ToXml<FieldFilterValue>() {
		@Override
		public Element call(Document document, FieldFilterValue fieldFilterValue) {
			Element element = createElement(document, TAG);
			setAttribute(element, TAG, fieldFilterValue.getValue());
			return element;
		}
	};
	
	public static final FromXml<FieldFilterValue> fromXml = new FromXml<FieldFilterValue>(){
		@Override
		public FieldFilterValue call(Element element) {
			FieldFilterValue fieldFilterValue = new FieldFilterValue();
			String value = element.getAttribute(TAG);
			fieldFilterValue.setValue(value);
			return fieldFilterValue;
		}
	}; 
}
