package com.indicee.api.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.report.view.filter.RelativeTimePeriod;

public class RelativeTimePeriodXml {
	public static final String TAG = "relativetimeperiod";
	
	private static enum Tag {
		timeperiod,
		rangestart,
		rangeend,
		referencetime
	}

	public static final ToXml<RelativeTimePeriod> toXml = new ToXml<RelativeTimePeriod>() {

		@Override
		public Element call(Document document, RelativeTimePeriod period) {
			Element element = createElement(document, TAG);
			setAttribute(element, Tag.timeperiod,    period.getTimePeriod());
			setAttribute(element, Tag.rangestart,    period.getRangeStart());
			setAttribute(element, Tag.rangeend,      period.getRangeEnd());
			setAttribute(element, Tag.referencetime, period.getReferenceTime());
			return element;
		}
	};
	
	public static final FromXml<RelativeTimePeriod> fromXml = new FromXml<RelativeTimePeriod>() {

		@Override
		public RelativeTimePeriod call(Element element) {
			RelativeTimePeriod period = new RelativeTimePeriod();
			period.setTimePeriod(getText(element, Tag.timeperiod));
			period.setRangeStart(getInteger(element, Tag.rangestart));
			period.setRangeEnd(getInteger(element, Tag.rangeend));
			period.setReferenceTime(getLong(element, Tag.referencetime));
			return period;
		}
		
	};
}
