package com.indicee.api.xml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.indicee.api.objects.report.view.attributes.Attribute;

public class ViewAttributeXml {
	
	public static final String TAG = "attribute";

	private enum Tag {
		name,
		type,
		value
	}
	
	public static final ToXml<Attribute> toXml = new ToXml<Attribute>() {

		@Override
		public Element call(Document document, Attribute attribute) {
			Element element = createElement(document, TAG);
			setAttribute(element, Tag.name,  attribute.getName());
			setAttribute(element, Tag.type,  attribute.getType());
			setAttribute(element, Tag.value, attribute.getValue());
			return element;
		}
		
	};
	
	public static final FromXml<Attribute> fromXml = new FromXml<Attribute>() {
		@Override
		public Attribute call(Element element) {
			Attribute attribute = new Attribute();
			attribute.setName (getText(element, Tag.name )  );
			attribute.setType (getText(element, Tag.type )  );
			attribute.setValue(getText(element, Tag.value ) );
			return attribute;
		}
	};
}
