package com.indicee.api.xml;

import java.util.HashSet;
import java.util.Set;

import com.indicee.api.objects.account.Account;
import com.indicee.api.objects.auth.Token;
import com.indicee.api.objects.identityprovider.IdentityProvider;
import com.indicee.api.objects.infospace.Infospace;
import com.indicee.api.objects.model.Dataset;
import com.indicee.api.objects.model.Entity;
import com.indicee.api.objects.model.Field;
import com.indicee.api.objects.model.Hierarchy;
import com.indicee.api.objects.model.Measure;
import com.indicee.api.objects.model.Model;
import com.indicee.api.objects.model.Relationship;
import com.indicee.api.objects.model.SourceField;
import com.indicee.api.objects.model.Table;
import com.indicee.api.objects.model.binding.Mapping;
import com.indicee.api.objects.model.binding.Projection;
import com.indicee.api.objects.model.binding.SourceTableBinding;
import com.indicee.api.objects.report.Metadata;
import com.indicee.api.objects.report.Metadatas;
import com.indicee.api.objects.report.Report;
import com.indicee.api.objects.report.VisualizationOptions;
import com.indicee.api.objects.report.axes.Axes;
import com.indicee.api.objects.report.view.axes.GroupFilter;
import com.indicee.api.objects.report.view.axes.ViewAxis;


/**
 * This is capturing the work to do in serializing the Java API Toolkit's POJOs
 * @author thaggie
 */
public class SerializationCheck {

	private static final Class<?>[] classes =  {
//		Account.class,
//		Ancillary.class,
		Axes.class,
//		Axis.class,
//		AxisColumn.class,
//		AxisSort.class,
//		Group.class,
//		Collection.class,
//		Column.class,
//		Consumer.class,
//		Contribution.class,
//		Dashboard.class,
//		FieldFilterValue.class,
//		FieldFilter.class,
//		RelativeTimePeriodFilter.class,
		GroupFilter.class,
		IdentityProvider.class,
		Infospace.class,
		Mapping.class,
		Metadata.class,
		Metadatas.class,
		Relationship.class,
		Report.class,
		Dataset.class,
		Entity.class,
		Field.class,
		Hierarchy.class,
		Measure.class,
		Model.class,
		Projection.class,
		SourceField.class,
		SourceTableBinding.class,
		Table.class,
		Token.class,
		ViewAxis.class,
		VisualizationOptions.class
	};
	
	public static void main(String[] args) {

		Set<Class<?>> done = new HashSet<Class<?>>();
		done.add(Account.class);

		System.out.println("Done:");
		for (Class<?> c : done) {
			String name = c.getName();
			System.out.println(name);
		}

		int i=0;
		System.out.println("TODO:");
		for (Class<?> c : classes) {
			
			if (!done.contains(c)) {
				++i;	
				String name = c.getName();
				System.out.println(name);
			}
			
		}
		System.out.println(i);
	}
}
